import { Application } from 'express';
import addWarning from "../middlewares/user/addWarning";
import deleteUser from "../middlewares/user/deleteUser";
import deleteWarning from "../middlewares/user/deleteWarning";
import getUser from "../middlewares/user/getUser";
import getUsersList from "../middlewares/user/getUsersList";
import getWarning from "../middlewares/user/getWarning";
import getWarningsList from "../middlewares/user/getWarningsList";
import updateUser from "../middlewares/user/updateUser";
import updateWarning from "../middlewares/user/updateWarning";
import addUser from '../middlewares/user/addUser';
import authenticated from '../middlewares/auth/authenticated';


 const usersRoute = (app: Application): void => {
    app.get('/users', authenticated(), getUsersList() );

    app.post('/users', authenticated(), addUser() );

    app.get('/users/:id', getUser() );

    app.get('/users/:id/warnings', getWarningsList() );
    
    app.get('/users/:userId/warnings/:warningId', getWarning() );

    app.post('/users/:id/warnings', addWarning());

    app.put('/users/:id', updateUser());

    app.put('/users/:userId/warnings/:warningId', updateWarning());
    
    app.delete('/users/:id', deleteUser());

    app.delete('/users/:userId/warnings/:warningId', deleteWarning());    
}

export default usersRoute;